controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\helpers\Html;
use yii\data\ActiveDataProvider;
use app\models\Prendas;
use app\models\Categorias;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $fotos= Prendas::find()->where(['portada'=>1])->all();
        foreach($fotos as $foto)
        {
            $carousel[]=[
            'content' => Html::img("@web/imgs/$foto->foto",["height"=>300,"width"=>200]),
            'caption' =>"<p style=color:blue class=bg-white>{$foto->precio}€</p>" . Html::a("Ver",["site/verprenda", 'id' => $foto->id], ['class' => 'btn btn-primary']),
        ];
        }
        
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['portada'=>1])]);
        $dataProvider1 = new ActiveDataProvider([
        'query' => Prendas::find()->where(['oferta'=>1])]);
        return $this->render('index',["carousel" => $carousel, "dataProvider" => $dataProvider, "dataProvider1" => $dataProvider1]);
    }
    
    public function actionVercategoria($tipo,$subtipo)
    {
        $categoria=Categorias::find()->where(['tipo'=>$tipo,'subtipo'=>$subtipo])->one();
        $dataProvider = new ActiveDataProvider([
        'query' => $categoria->getPrendas()]);
        return $this->render('vercategoria',["tipo" => $tipo, "subtipo" => $subtipo, "dataProvider" => $dataProvider]);
    }
    
    public function actionVercategoriatipo($tipo)
    {
        $categorias= Categorias::find()->where(['tipo'=>$tipo])->all();
        $idCategorias=[];
        foreach($categorias as $categoria)
        {
            $idCategorias[]=$categoria->id;
        }
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['id_categorias'=>$idCategorias])]);
        return $this->render('vercategoria',["tipo" => $tipo, "subtipo" => "todo", "dataProvider" => $dataProvider]);
    }
    
    /*
     * Esta accion muestra los datos de cada prenda
     */
    public function actionVerprenda($id)
    {
        $prenda= Prendas::findOne($id);
        return $this->render('verprenda',["prenda" => $prenda]);  
    }
    
    public function actionOfertas()
    {
        $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['oferta'=>1])]);
        return $this->render('ofertas',["dataProvider" => $dataProvider, "migas" => true]); 
    }
    
    public function actionDestacados()
    {
        $categorias= Categorias::find()->select('tipo')->distinct()->all();
        return $this->render('destacados',["categorias" => $categorias]); 
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
}

views/site/_listar.php
<?php
use yii\helpers\Html;


echo Html::img("@web/imgs/$model->foto",["height"=>300,"width"=>200]);
echo "<br>";
echo "{$model->precio}€";
echo "<br>";
echo Html::a("Ver",["site/verprenda", 'id' => $model->id], ['class' => 'btn btn-primary']);

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/destacados.php
<?php
use app\models\Categorias;
use app\models\Prendas;
use yii\data\ActiveDataProvider;
use yii\widgets\ListView;

foreach($categorias as $categoria)
{
    $categorias2=Categorias::find()->where(["tipo"=>$categoria->tipo])->all();
    $idCategorias=[];
        foreach($categorias2 as $categoria2)
        {
            $idCategorias[]=$categoria2->id;
        }
    $dataProvider = new ActiveDataProvider([
        'query' => Prendas::find()->where(['portada'=>1,'id_categorias'=>$idCategorias])]);
    
?>
<h1><?= strtoupper($categoria->tipo) ?></h1>

<?php
    
    echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
    "itemOptions" => [
        'class' => 'col-lg-4 border m-2 p-2',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"

    ]);
    
    echo "<br>";
}

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

use yii\bootstrap4\Carousel;
use yii\helpers\Html;
use yii\widgets\ListView;


$this->title = 'Alpe Shop';
?>

<h2 style="float: right">Moda</h2>
<br><br>
<?php
    echo Carousel::widget([
        'items' => $carousel,
        'options'=>[
            "style" => ["height"=>"300px","width"=>"200px","margin"=>"auto"]
        ],
    ]);
    
echo "<br><br>";   

    echo $this->render('ofertas',["dataProvider" => $dataProvider1, "migas" => false]); 
    
    echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
    "itemOptions" => [
        'class' => 'col-lg-4 border m-2 p-2',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"

    ]);
    
?>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n<div class=\"col-lg-3\">{input}</div>\n<div class=\"col-lg-8\">{error}</div>",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/ofertas.php
<?php
use yii\helpers\Html;
use dominus77\owlcarousel2\WrapCarousel;
use yii\widgets\ListView;

if($migas)
{
    $this->params['breadcrumbs'][] = "Ofertas";
}
?>

<h2>Ofertas</h2>
<br>
<?php WrapCarousel::begin([
    //'theme' => \dominus77\owlcarousel2\Carousel::THEME_GREEN, // THEME_DEFAULT, THEME_GREEN
    //'tag' => 'div', // container tag name, default div
    //'containerOptions' => [/* ... */], // container html options
    'clientOptions' => [
        'autoplay' => true,
        'loop' => true,
        'margin' => 10,
        'nav' => true,
        'responsive' => [
            0 => [
                'items' => 1,
            ],
            600 => [
                'items' => 3,
            ],
            1000 => [
                'items' => 5,
            ],
        ],
    ],
       
]); 

    echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
    "itemOptions" => [
        'class' => 'col-lg-12',
    ],
    "options" => [
        'class' => 'row',
        'tag' => false //Necesario para que no me agrupe todo el ListView dentro de un <div>
    ],
    'layout'=>"{items}"

    ]);

WrapCarousel::end()
        
?>

views/site/vercategoria.php
<?php
use yii\widgets\Breadcrumbs;
use yii\widgets\ListView;

$this->params['breadcrumbs'][] = ['label' => $tipo, 'url' => ['site/vercategoriatipo', 'tipo' => $tipo]];
$this->params['breadcrumbs'][] = $subtipo;

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
    "itemOptions" => [
        'class' => 'col-lg-4 border m-2 p-2',
    ],
    "options" => [
        'class' => 'row',
    ],
    'layout'=>"{items}"

    ]);

views/site/verprenda.php
<?php
use yii\widgets\Breadcrumbs;
use newerton\fancybox\FancyBox;
use yii\helpers\Html;

$categoria=$prenda->getCategorias()->one();
//$categoria=$prenda->categorias; //Hace lo mismo que la fila anterior
$fotos=$prenda->getFotos()->all();
$caracteristicas=$prenda->getCaracteristicas()->all();

$this->params['breadcrumbs'][] = ['label' => $categoria->tipo, 'url' => ['site/vercategoriatipo', 'tipo' => $categoria->tipo]];
$this->params['breadcrumbs'][] = ['label' => $categoria->subtipo, 'url' => ['/site/vercategoria','tipo'=>$categoria->tipo,"subtipo"=>$categoria->subtipo]];
$this->params['breadcrumbs'][] = $prenda->titulo;

echo FancyBox::widget([
    'target' => 'a[rel=fancybox]',
    'helpers' => true,
    'mouse' => true,
    'config' => [
        'maxWidth' => '90%',
        'maxHeight' => '90%',
        'playSpeed' => 7000,
        'padding' => 0,
        'fitToView' => false,
        'width' => '70%',
        'height' => '70%',
        'autoSize' => false,
        'closeClick' => false,
        'openEffect' => 'elastic',
        'closeEffect' => 'elastic',
        'prevEffect' => 'elastic',
        'nextEffect' => 'elastic',
        'closeBtn' => false,
        'openOpacity' => true,
        'helpers' => [
            'title' => ['type' => 'float'],
            'buttons' => [],
            'thumbs' => ['width' => 68, 'height' => 50],
            'overlay' => [
                'css' => [
                    'background' => 'rgba(0, 0, 0, 0.8)',
                ]
            ]
        ],
    ]
]);

foreach ($fotos as $foto) 
{
        echo Html::a(Html::img("@web/imgs/{$foto->ruta}",["height"=>300,"width"=>200,"style" => "margin:5px;"]), "@web/imgs/{$foto->ruta}", ['rel' => 'fancybox']);    
}
?>
<br><br>
<h3><?= $prenda->titulo ?></h3>
<h4><?= $prenda->referencia ?></h4>

<ul>
<?php
foreach($caracteristicas as $caracteristica)
{
?>
    <li><?= $caracteristica->caracteristica ?></li>
<?php    
}
?>
</ul>


<?php
echo "PRECIO: " . $prenda->precio . "€<br>";
if($prenda->descuento!=null)
{
    echo "DESCUENTO: " . $prenda->descuento . "€<br>";
}

?>